// posdlg.cpp : implementation file
//

#include "stdafx.h"
#include "test.h"
#include "posdlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPosDlg dialog


void CPosDlg::setPosition(geometryClass *geo)
{
	V3 pos, ext;
	geo->getExtents(ext);

	pos[0] = m_xPos;
	pos[1] = m_yPos;
	pos[2] = m_zPos;

	if (m_xAlign == "Left")
		pos[0] += ext[0]/2.0;
	else if (m_xAlign == "Right")
		pos[0] -= ext[0]/2.0;

	if (m_yAlign == "Bottom")
		pos[1] += ext[1]/2.0;
	else if (m_yAlign == "Top")
		pos[1] -= ext[1]/2.0;

	if (m_zAlign == "Left")
		pos[2] += ext[2]/2.0;
	else if (m_yAlign == "Right")
		pos[2] -= ext[2]/2.0;

	geo->scale(m_scale);
	geo->rotate(1, m_yRot*DEG_TO_RAD);
	geo->rotate(0, m_xRot*DEG_TO_RAD);
	geo->rotate(2, m_zRot*DEG_TO_RAD);
	geo->setPosition(pos);

}

CPosDlg::CPosDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPosDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPosDlg)
	m_xPos = 0.0;
	m_yPos = 0.0;
	m_zPos = 0.0;
	m_scale = 1.0f;
	m_xRot = 0.0f;
	m_yRot = 0.0f;
	m_zRot = 0.0f;
	m_xAlign = _T("Center");
	m_yAlign = _T("Center");
	m_zAlign = _T("Center");
	//}}AFX_DATA_INIT
}


void CPosDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPosDlg)
	DDX_Text(pDX, ID_POS_X, m_xPos);
	DDX_Text(pDX, ID_POS_Y, m_yPos);
	DDX_Text(pDX, ID_POS_Z, m_zPos);
	DDX_Text(pDX, ID_SCALE, m_scale);
	DDV_MinMaxFloat(pDX, m_scale, 1.e-005f, 10000.f);
	DDX_Text(pDX, ID_ROT_X, m_xRot);
	DDX_Text(pDX, ID_ROT_Y, m_yRot);
	DDX_Text(pDX, ID_ROT_Z, m_zRot);
	DDX_CBString(pDX, ID_X_ALIGN, m_xAlign);
	DDX_CBString(pDX, ID_Y_ALIGN, m_yAlign);
	DDX_CBString(pDX, ID_Z_ALIGN, m_zAlign);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPosDlg, CDialog)
	//{{AFX_MSG_MAP(CPosDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CPosDlg message handlers

void CPosDlg::OnOK() 
{
	// TODO: Add extra validation here
	
	UpdateData(TRUE);
	CDialog::OnOK();

}
