//**********************************************************************
//  DIVE Laboratories, Inc.
//  Copyright(c) 1995
//  All rights reserved.
//  FILE:   SLINK.HPP
//
//  DESCRIPTION
//
//  Author: Brian D. Green
//
//  Modification History:
//  3/22/95 Created
//
//**********************************************************************
#ifndef _SLINK2_HPP
#define _SLINK2_HPP
#include <stddef.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#define 	DEFAULT		-1

// -------------------------------------------------------------------

class listNodeClass {
 
public:

    int	  key;
    void  *obj;
    listNodeClass *next;

    listNodeClass( void *listOBJ, int listKEY=DEFAULT );
    listNodeClass();

   ~listNodeClass();

    };

// -------------------------------------------------------------------

class sLinkClass {
  
   protected:

      listNodeClass *listPtr;
      listNodeClass *head, *tail;
		int count;

    //------------------------------------------------------------
    // user specified print and remove functions
    //------------------------------------------------------------

   public:

    //------------------------------------------------------------
    // list manipulation fcns
    //------------------------------------------------------------

      void 	next();
      void	clear();
      void 	reset();

      int	isEmpty();
      int	atEnd();
		int   length();
    //------------------------------------------------------------
    // data manipulation fcns
    //------------------------------------------------------------
  
      int 	find( int listKEY );
      int 	findNext( int listKEY );
      int	inList( int listKEY );
      int	inList( void *listOBJ);

      int    getKey();

		void  *get();
      void  *getData( );
      void  *getData( int listKEY);
      void  *getDataK( int& listKEY );

    //------------------------------------------------------------
    // node deletion functions
    //------------------------------------------------------------
             
      void remove( int listKEY=DEFAULT );
      void remove( void *listOBJ );

    //------------------------------------------------------------
    // node modification function
    //------------------------------------------------------------
             
      void modify( void *listOBJ,int listKEY=DEFAULT );

    //------------------------------------------------------------
    // node inserting functions
    //------------------------------------------------------------
             
      void add( void *listOBJ, int listKEY=DEFAULT );
      void append( void *listOBJ, int listKEY=DEFAULT );

    //------------------------------------------------------------
    // overloaded operators
    //------------------------------------------------------------

      void operator=( sLinkClass* otherList );
             
    // ------------------------------------------------------------
    // constructors & destructors
    // ------------------------------------------------------------

      sLinkClass();
      sLinkClass( sLinkClass* otherList );

     ~sLinkClass();
};

#endif

